#include <bits/stdc++.h>
using namespace std;

#define rep(i,a,b) for (int i = a; i < b; i++)
#define trav(a,b) for (auto a : b)
#define all(x) begin(x),end(x)
#define lld long long 

void Solve() {
	int n;
	cin >> n;
	vector<set<int> > g(n);
	vector<int> degree(n);
	vector<int> counter(n,1);
	for (int i = 0; i <  n - 1; i++) {
		int st, et;
		cin >> st >> et;
		--st; --et;
		g[st].insert(et);
		g[et].insert(st);
		degree[st]++;
		degree[et]++;
	}

	int nodes=n;
	set<array<int,2>> s;
	for(int i=0;i<n;i++){
	     if(degree[i]==1)
		  s.insert({counter[i],i});
	}
	while(nodes > 2){
	     auto [c,x]=*s.begin();
	     s.erase(s.begin());

	     auto y=*g[x].begin();
	     if(counter[y]<counter[x]){
		  cout<<"NO\n";
		  return;
	     }
	     counter[y]+=counter[x];
	     g[y].erase(x);
	     degree[y]--;
	     if(degree[y]==1){
		  s.insert({counter[y],y});
	     }
	     nodes--;
	}

	cout<<"YES\n";
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	// cin >> tt;
	while (tt--) Solve();
	return 0;
}
