#include <bits/stdc++.h>
using namespace std;

#define rep(i,a,b) for (int i = a; i < b; i++)
#define trav(a,b) for (auto a : b)
#define all(x) begin(x),end(x)
#define lld long long 
string c,p;
int deg[3];
map<char,int> m;
vector<pair<int,int> > nei[3][3];

vector<int> euler(const vector< vector<int> >& g, int n, int s) {
	vector<int> ans, idx(n, 0), st;
	st.push_back(s);
	while (!st.empty()) {
		int u = st.back();
		if (idx[u] < (int) g[u].size()) st.push_back(g[u][idx[u]]), ++idx[u];
		else ans.push_back(u), st.pop_back();
	}
	reverse(ans.begin(), ans.end());
	return ans;
	
}
int ptr[3][3];
vector<vector<int> >gr;

void Solve() {
	int n;
	cin>>n;
	cin>>c>>p;
	m['-']=0;
	m['C']=1;
	m['M']=2;
	rep(i,0,n){
		if(c[i]!=p[i]){
			deg[m[c[i]]]--;
			deg[m[p[i]]]++;
			nei[m[c[i]]][m[p[i]]].push_back({(m[p[i]]!=0)&(m[c[i]]!=0),i});
		}
	}
	rep(j,0,3){
		rep(k,0,3){
			sort(nei[j][k].begin(),nei[j][k].end());
		}
	}
	//cout<<deg[0]<<" "<<deg[1]<<" "<<deg[2]<<endl;
	rep(k,1,3){
		while(deg[k]>0){
			bool el=false;
			rep(j,0,3){
				if(nei[j][k].size()>0 && nei[j][k][nei[j][k].size()-1].first==1){
					//cout<<j<<" U"<<k<<" "<<nei[j][k][nei[j][k].size()-1].first<<endl;
					int u=nei[j][k][nei[j][k].size()-1].second;
					nei[j][k].pop_back();
					nei[j][0].push_back({0,u});
					deg[k]--;
					deg[0]++;
					el=true;
					break;
				}
			}
			if(!el){
				rep(j,0,3){
					if(nei[j][k].size()>0){
						//cout<<j<<" U"<<k<<" "<<nei[j][k][nei[j][k].size()-1].first<<endl;
						int u=nei[j][k][nei[j][k].size()-1].second;
						nei[j][k].pop_back();
						nei[j][0].push_back({0,u});
						deg[k]--;
						deg[0]++;
						el=true;
						break;
					}
				}
			}
		}
	}
	gr.resize(3);
	rep(j,0,3){
		rep(k,0,3){
			if(j==k)continue;
			ptr[j][k]=0;
			//cout<<nei[j][k].size()<<" "<<j<<" "<<k<<endl;
			rep(l,0,(int)nei[j][k].size()){
				//cout<<j<<" "<<k<<endl;
				gr[j].push_back(k);
			}
		}
	}
	vector<int> ans=euler(gr,3,0);
	
	int sz=0;
	rep(i,0,(int)ans.size()-1){
		int u=ans[i];
		int v=ans[i+1];
		int idx=nei[u][v][ptr[u][v]].second;
		ptr[u][v]++;
		// cout<<u<<" "<<v<<endl;
		sz++;
		if(u!=0){
			sz++;
		}
		if(v!=0){
			sz++;
		}
	}
	rep(j,0,3){
		rep(k,0,3)ptr[j][k]=0;
	}
	cout<<sz<<"\n";
	rep(i,0,(int)ans.size()-1){
		int u=ans[i];
		int v=ans[i+1];
		int idx=nei[u][v][ptr[u][v]].second;
		ptr[u][v]++;
		cout<<"DRIVE "<<idx+1<<"\n";
		if(u!=0){
			cout<<"DROPOFF\n";
		}
		if(v!=0){
			cout<<"PICKUP\n";
		}
	}
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	// cin >> tt;
	while (tt--) Solve();
	return 0;
}
